-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}

local gear_A = 0
local gearIndex = 0

local function onInit()
  electrics.values['disp_R'] = 0
  electrics.values['disp_N'] = 0
  electrics.values['disp_1'] = 0
  electrics.values['disp_2'] = 0
  electrics.values['disp_3'] = 0
  electrics.values['disp_4'] = 0
  electrics.values['disp_5'] = 0
  electrics.values['disp_6'] = 0
  electrics.values['disp_7'] = 0
  electrics.values['disp_8'] = 0
  electrics.values['disp_Pa'] = 0
  electrics.values['disp_Ra'] = 0
  electrics.values['disp_Na'] = 0
  electrics.values['disp_Da'] = 0
end

local function reset()
  onInit()
end

local function updateGFX(dt)
  gearIndex = electrics.values.gearIndex or 0
  gear_A = electrics.values['gear_A'] or 0
--Rev
  if gearIndex < -0.5 then
    electrics.values['disp_R'] = 1
  else
    electrics.values['disp_R'] = 0
  end
--Neutral
  if gearIndex >= -0.5 and gearIndex < 0.5 then
    electrics.values['disp_N'] = 1
  else
    electrics.values['disp_N'] = 0
  end
--First
for i=-1,14,1 do
local electric = "disp_" .. tostring(i)
if gearIndex == i then
    electrics.values[electric] = 1
else
    electrics.values[electric] = 0
end
end

--Park Auto
  if gear_A < 0.1 then
    electrics.values['disp_Pa'] = 1
  else
    electrics.values['disp_Pa'] = 0
  end
--Reverse Auto
  if gear_A >= 0.1 and gear_A < 0.21 then
    electrics.values['disp_Ra'] = 1
  else
    electrics.values['disp_Ra'] = 0
  end
--Neutral Auto
  if gear_A >= 0.21 and gear_A < 0.41 then
    electrics.values['disp_Na'] = 1
  else
    electrics.values['disp_Na'] = 0
  end
--Drive Auto	
    if gear_A >= 0.41 and gear_A < 0.61 then
    electrics.values['disp_Da'] = 1
    --if in D ignore the gearIndex digits
    electrics.values['disp_1'] = 0
    electrics.values['disp_2'] = 0
    electrics.values['disp_3'] = 0
    electrics.values['disp_4'] = 0
    electrics.values['disp_5'] = 0
    electrics.values['disp_6'] = 0
    electrics.values['disp_7'] = 0
    electrics.values['disp_8'] = 0
  else
    electrics.values['disp_Da'] = 0

  end

end

-- public interface
M.onInit      = onInit
M.reset     = reset
M.updateGFX = updateGFX

return M